package org.xbib.io.webdav.common;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

public class FieldValueParser {

    /**
     * Tokenize lists of token and quoted-url
     *
     * @param list field value
     */
    public static List<String> tokenizeList(String list) {

        String[] split = list.split(",");
        if (split.length == 1) {
            return Collections.singletonList(split[0].trim());
        } else {
            List<String> result = new ArrayList<String>();
            String inCodedUrl = null;
            for (String t : split) {
                String trimmed = t.trim();
                // handle quoted-url containing ","
                if (trimmed.startsWith("<") && !trimmed.endsWith(">")) {
                    inCodedUrl = trimmed + ",";
                } else if (inCodedUrl != null && trimmed.endsWith(">")) {
                    inCodedUrl += trimmed;
                    result.add(inCodedUrl);
                    inCodedUrl = null;
                } else {
                    if (trimmed.length() != 0) {
                        result.add(trimmed);
                    }
                }
            }
            return Collections.unmodifiableList(result);
        }
    }
}
